#include "typename.h"

using namespace Frost;

s_bool TypeName::TryDecorateType(const TypeName& mRef, TypeName& mType, s_wptr<Module> pModule, const s_ctnr<s_str>& lContext) const
{
    // Check if types match
    if (mRef.sType != sNestedType)
    {
        if (!mRef.sType.EndsWith(sNakedType))
            return false;

        // TODO : inheritance context

        if (!mRef.sType.EndsWith(sNestedType))
        {
            s_ctnr<s_str> lLocalContext = lContext;
            s_ctnr<s_str> lWords = mRef.sType.Cut("::");
            s_ctnr<s_str>::iterator iter;
            foreach (iter, lWords)
                lLocalContext.PushBack(*iter);

            lLocalContext.PopBack();
            bLocalContextBuilt = true;

            if (lLocalContext.IsEmpty() || lLocalContext.GetSize() < lNamespaces.GetSize()+lMemberships.GetSize())
                return false;

            for (s_uint i = 0; i < lNamespaces.GetSize(); ++i)
            {
                if (lLocalContext[i] != lNamespaces[i])
                    return false;
            }

            for (s_uint i = 0; i < lMemberships.GetSize(); ++i)
            {
                if (lLocalContext[i+lNamespaces.GetSize()] != lMemberships[i])
                    return false;
            }
        }
        else if (mRef.sType[mRef.sType.GetSize()-sNestedType.GetSize()-1] != ':')
            return false;
    }

    // Check if type is available in current context
    if (bIsPrivate || bIsProtected)
    {

        return false;
    }

    mType = mRef;

    mType.bIsTemplate = bIsTemplate;
    mType.bIsTypedef = bIsTypedef;
    mType.bIsEnum = bIsEnum;
    mType.bIsNested = bIsNested;

    mType.sNamespace = sNamespace;
    mType.lNamespaces = lNamespaces;
    mType.sMembership = sMembership;
    mType.lMemberships = lMemberships;

    mType.pModule = pModule;

    mType.sType = sType;
    mType.sFullType = sFullType;
    mType.sNakedType = sNakedType;
    mType.sFullNakedType = sFullNakedType;
    mType.sNestedType = sNestedType;

    return true;

    /*if (mType.sNakedType == sNakedType)
    {
        mType = mRef;

        mType.bIsTemplate = bIsTemplate;
        mType.bIsTypedef = bIsTypedef;
        mType.bIsEnum = bIsEnum;
        mType.bIsNested = bIsNested;

        mType.sNamespace = sNamespace;
        mType.lNamespaces = lNamespaces;
        mType.sMembership = sMembership;
        mType.lMemberships = lMemberships;

        mType.pModule = pModule;

        if (mType.sMembership.IsEmpty())
        {
            if (mType.sNamespace.IsEmpty())
            {
                mType.sFullType = mType.sType;
                mType.sFullNakedType = mType.sNakedType;
                mType.sNestedType = mType.sMembership + "::" + mType.sNakedType;
            }
            else
            {
                mType.sFullType = mType.sNamespace + "::" + mType.sType;
                mType.sFullNakedType = mType.sNamespace + "::" + mType.sNakedType;
            }

            mType.sNestedType = mType.sNakedType;
        }
        else
        {
            if (mType.sNamespace.IsEmpty())
            {
                mType.sFullType = mType.sType;
                mType.sFullNakedType = mType.sNakedType;
            }
            else
            {
                mType.sFullType = mType.sNamespace + "::" + mType.sMembership + "::" + mType.sType;
                mType.sFullNakedType = mType.sNamespace + "::" + mType.sMembership + "::" + mType.sNakedType;
            }

            mType.sNestedType = mType.sMembership + "::" + mType.sNakedType;
        }

        return true;
    }
    else
    {
        mType = mRef;

        s_uint uiPos = sFullNakedType.FindPos(mType.sNakedType);
        if (!uiPos.IsValid())
            return false;

        if (uiPos + mType.sNakedType.GetSize() != sFullNakedType.GetSize())
            return false;

        if (uiPos != 0 && sFullNakedType[uiPos-1] != ':')
            return false;

        mType.sNakedType = sNakedType;
        mType.sType.EraseFromStart(mType.sType.FindPos(sNakedType));

        mType.bIsTemplate = bIsTemplate;
        mType.bIsTypedef = bIsTypedef;
        mType.bIsEnum = bIsEnum;
        mType.bIsNested = bIsNested;

        mType.sNamespace = sNamespace;
        mType.lNamespaces = lNamespaces;
        mType.sMembership = sMembership;
        mType.lMemberships = lMemberships;

        mType.pModule = pModule;

        if (mType.sMembership.IsEmpty())
        {
            if (mType.sNamespace.IsEmpty())
            {
                mType.sFullType = mType.sType;
                mType.sFullNakedType = mType.sNakedType;
                mType.sNestedType = mType.sMembership + "::" + mType.sNakedType;
            }
            else
            {
                mType.sFullType = mType.sNamespace + "::" + mType.sType;
                mType.sFullNakedType = mType.sNamespace + "::" + mType.sNakedType;
            }

            mType.sNestedType = mType.sNakedType;
        }
        else
        {
            if (mType.sNamespace.IsEmpty())
            {
                mType.sFullType = mType.sType;
                mType.sFullNakedType = mType.sNakedType;
            }
            else
            {
                mType.sFullType = mType.sNamespace + "::" + mType.sMembership + "::" + mType.sType;
                mType.sFullNakedType = mType.sNamespace + "::" + mType.sMembership + "::" + mType.sNakedType;
            }

            mType.sNestedType = mType.sMembership + "::" + mType.sNakedType;
        }

        return true;
    }*/
}

s_str TypeName::Qualify()
{
    if (lQualifiers.IsEmpty() && sTemplateParams.IsEmpty())
        return "";

    s_str sFirst;
    s_str sSecond;

    s_uint uiStart = 0;

    s_bool bConst;
    s_bool bMutable;
    s_bool bVolatile;

    while (uiStart < lQualifiers.GetSize())
    {
        if (lQualifiers[uiStart] == "const")
        {
            if (bMutable)
                return "qualifiers 'const' and 'mutable' are incompatible";
            if (bConst)
                return "invalid qualifier 'const const'";

            sFirst += "const ";
            bConst = true;
        }
        else if (lQualifiers[uiStart] == "mutable")
        {
            if (bConst)
                return "qualifiers 'const' and 'mutable' are incompatible";
            if (bMutable)
                return "invalid qualifier 'mutable mutable'";

            sFirst += "mutable ";
            bMutable = true;
        }
        else if (lQualifiers[uiStart] == "volatile")
        {
            if (bVolatile)
                return "invalid qualifier 'volatile volatile'";

            sFirst += "volatile ";
            bVolatile = true;
        }
        else
            break;

        ++uiStart;
    }

    for (s_uint i = uiStart; i < lQualifiers.GetSize(); ++i)
    {
        if (lQualifiers[i] == "mutable")
            return "'mutable' qualifier can only be found close to a plain type";

        if (lQualifiers[i] == "*" || lQualifiers[i] == "&")
        {
            sSecond += lQualifiers[i];
            bIsPointer = true;
        }
        else
            sSecond += " "+lQualifiers[i];
    }

    sType = sFirst + sType + sTemplateParams + sSecond;
    sFullType = sFirst + sFullType + sTemplateParams + sSecond;
    sNestedType = sFirst + sNestedType + sTemplateParams + sSecond;

    return "";
}

s_str::string StringConverter<string_element, TypeName>::Convert( const TypeName& mType )
{
    return mType.sType.Get();
}
